#ifndef MAJONG_H
#define MAJONG_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

/*
 *
 *  classes
 *
 */

typedef struct {
    int mentsu;
    int tahtsu;
    int toitsu;
    int float_suit_tiles;
    int dead_suit_tiles;
    int float_honor_tiles;
    int dead_honor_tiles;
} t_melds;

typedef struct {
    int han;
    int fu;
    void *data;
} t_winning_hand;

typedef struct {
    t_winning_hand *winning_hand;
    int count;
} t_winning_hand_set;


/*
 *
 *  function prototypes
 *
 */

void    try_and_print(int *tiles, int tile_count);
void    benchmark(int repeat_times);
int     compare_int(const int *a, const int *b);
int     random_haipai(int *buf, int limit);
void    print_usage();

int     tilearray2str(int *tiles, int tile_count, char *buf, int buf_size);
int     honorchr2tilenum(char c);
int     str2tilearray(char *str, int *buf, int buf_size);

int     shanten(int *tiles, int tile_count);
int     count_mentsu_shanten(int *tiles);
int     count_seventwins_shanten (int *tiles);
int     count_kokushi_shanten (int *tiles);
t_melds count_max_melds(int *tiles);
t_melds max_available_melds_in_suit(int *tiles);
t_melds max_available_melds_in_honor(int *tiles);
int     get_max_meld_comparer_in_suit_fast(int *tiles, int base, int repeater);

int     win(int *tiles, int tile_count);
int     can_win_with(int *tiles, int tile_count, int win_tile);
int     win_mentsu(int *tiles);
int     get_all_mentsu(int *tiles);
int     win_seventwins(int *tiles);
int     win_kokushi(int *tiles);

int brute_force_tsumo(int *tiles, int shanten_count);
int brute_force_shanten_search(int *tiles);

/*
 *
 *  global variables 
 *  (i know it's better to use const or enum, but i can't remember how to write. mandokuse.)
 *
 */

extern char *tile_chr[];
extern char honor_chrs[];

extern int opt_chin;
extern int opt_time;
extern int opt_brute;
extern int brute_level;
extern t_melds last_max_melds;
extern int last_mentsu_shanten;
extern int last_seventwins_shanten;
extern int last_kokushi_shanten;

#endif				/* MAJONG_H */
